
//  VilkkuvaPalloApplet.java  (c) Kari Laitinen

//  http://www.naturalprogramming.com/

//  2005-11-16  Tiedosto luotu.
//  2006-10-19  Viimeisin muutos

//  Englanninkielinen versio tst ohjelmasta on AnimationDemoApplet.java

//  Kun apletteihin listn System.out.print()-kutsuja, niiden
//  tuottavat tekstit ilmestyvt mustaan komentoriviikkunaan.
//  Nit kutsuja voidaan nin hydynt aplettien testauksessa.

import java.awt.* ;
import javax.swing.* ;

public class VilkkuvaPalloApplet extends JApplet
                                 implements Runnable
{
   int apletin_leveys, apletin_korkeus ;

   Thread  tahdistussaie  =  null ;

   boolean  saietta_on_suoritettava  =  false ;

   boolean  palloa_on_naytettava  =  true ;

   int pallon_paikka_x, pallon_paikka_y ;

   Color  pallon_vari  =  Color.cyan ;

   public void init()
   {
      apletin_leveys   =  getSize().width ;
      apletin_korkeus  =  getSize().height ;
      pallon_paikka_x  =  apletin_leveys / 2  -  40 ;
      pallon_paikka_y  =  apletin_korkeus / 2  -  40 ;
      System.out.print( "\n init()-metodi suoritettu. " ) ;
   }

   public void start()
   {
      if ( tahdistussaie  ==  null )
      {
         tahdistussaie  =  new  Thread( this ) ;

         saietta_on_suoritettava  =  true ;

         tahdistussaie.start() ;
      }

      System.out.print( "\n start()-metodi suoritettu. " ) ;
   }

   public void stop()
   {
      if ( tahdistussaie  !=  null )
      {
         tahdistussaie.interrupt() ;

         saietta_on_suoritettava  =  false ;

         tahdistussaie  =  null ;
      }

      System.out.print( "\n stop()-metodi suoritettu. " ) ;
   }

   public void run()
   {
      System.out.print( "\n run()-metodi aloitti ." ) ;

      while ( saietta_on_suoritettava  ==  true )
      {
         System.out.print( " X " ) ;

         try
         {
            Thread.sleep( 1000 ) ;  //  1000 millisekunnin viive
         }
         catch ( InterruptedException  vangittu_poikkeus )
         {
            saietta_on_suoritettava  =  false ;
         }

         repaint() ;
      }

      System.out.print( "\n run()-metodi lopetti. " ) ;
   }

   public void paint( Graphics graphics )
   {
      super.paint( graphics ) ;

      if ( palloa_on_naytettava  ==  true )
      {
         graphics.setColor( pallon_vari ) ;

         graphics.fillOval( pallon_paikka_x, pallon_paikka_y, 80, 80 ) ;

         palloa_on_naytettava  =  false ;
      }
      else
      {
         palloa_on_naytettava  =  true ;
      }

   }
}
























